package nc.ui.cm.fetchdata.action;

package ..deTemp.1730018415421;

import java.awt.event.ActionEvent;
import java.util.ArrayList;
import nc.bs.framework.common.NCLocator;
import nc.itf.mmpac.apply.task.ITaskAMaintainService;
import nc.itf.pubapp.pub.smart.IBillQueryService;
import nc.itf.uap.IUAPQueryBS;
import nc.itf.uap.busibean.SysinitAccessor;
import nc.jdbc.framework.processor.BeanProcessor;
import nc.jdbc.framework.processor.ColumnListProcessor;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.jdbc.framework.processor.ResultSetProcessor;
import nc.md.data.access.NCObject;
import nc.ui.cm.fetchdata.view.ListFetchDataMainPnl;
import nc.ui.uif2.AppEventListener;
import nc.ui.uif2.NCAction;
import nc.ui.uif2.model.BillManageModel;
import nc.vo.cm.fetchdata.entity.PullDataStateVO;
import nc.vo.jcom.xml.XMLUtil;
import nc.vo.mmpac.apply.task.entity.AggTaskAVO;
import nc.vo.mmpac.apply.task.entity.TaskABVO;
import nc.vo.mmpac.apply.task.entity.TaskAHVO;
import nc.vo.org.DeptVO;
import nc.vo.org.OrgVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.MultiLangText;
import nc.vo.pub.lang.UFDouble;
import nc.vo.tmpub.util.StringUtil;

public class ZysbdCopyAction extends NCAction {
  private IUAPQueryBS iq;
  
  private ListFetchDataMainPnl listFetchDataMainPnl;
  
  private BillManageModel model;
  
  public ZysbdCopyAction() {
    setBtnName("生产数据同步");
    setCode("zysbdCopyAction");
  }
  
  public void doAction(ActionEvent arg0) throws Exception {
    String orgPk = null;
    PullDataStateVO[] allVOs = getFetchDataMainAllVO();
    byte b;
    int i;
    PullDataStateVO[] arrayOfPullDataStateVO1;
    for (i = (arrayOfPullDataStateVO1 = allVOs).length, b = 0; b < i; ) {
      PullDataStateVO allVO = arrayOfPullDataStateVO1[b];
      String pk_org = allVO.getPk_org();
      Integer pulldatatype = allVO.getPulldatatype();
      String ccostcenterid = allVO.getCcostcenterid();
      if (pulldatatype.intValue() != 2)
        return; 
      String sphxy01 = SysinitAccessor.getInstance().getParaString(
          pk_org, "sphxy01");
      if (StringUtil.isNull(sphxy01))
        return; 
      String sphxy02 = SysinitAccessor.getInstance().getParaString(
          pk_org, "sphxy02");
      if (StringUtil.isNull(sphxy02))
        return; 
      ArrayList<String> lspk = new ArrayList<String>();
      if (orgPk == null)
        orgPk = getOrgPk(); 
      String deptsql = "select b.pk_dept from resa_costcenter a \nleft join resa_ccdepts b on a.pk_costcenter=b.pk_costcenter \nwhere 1=1 and a.pk_org='" + 
        
        pk_org + "' and a.pk_costcenter='" + ccostcenterid + "' \n";
      String oldPkDept = (String)this.iq.executeQuery(deptsql, (ResultSetProcessor)new ColumnProcessor());
      String sql = " SELECT a.PK_TA FROM mm_ta a \n INNER JOIN mm_ta_b b ON a.pk_ta = b.pk_ta \n WHERE 1=1 AND a.dr = 0 AND b.dr = 0 \n AND a.pk_org = '" + 

        
        pk_org + "' and pk_dept='" + oldPkDept + "' \n" + 
        " AND b.dtaskdate >= to_char(to_date('202409','yyyyMM'),'YYYY-MM-DD HH24:MI:SS') \n" + 
        " AND b.dtaskdate <= AND b.dtaskdate <= concat(to_char(last_day(to_date('202409','yyyyMM')),'YYYY-MM-DD'),' 23:59:59') ";
      lspk = (ArrayList<String>)getIq().executeQuery(sql, (ResultSetProcessor)new ColumnListProcessor());
      IBillQueryService billQuery = 
        (IBillQueryService)NCLocator.getInstance().lookup(IBillQueryService.class);
      AggTaskAVO[] taskaVos = (AggTaskAVO[])billQuery.queryAbstractBillsByPks(AggTaskAVO.class, lspk.<String>toArray(new String[0]));
      byte b1;
      int j;
      AggTaskAVO[] arrayOfAggTaskAVO1;
      for (j = (arrayOfAggTaskAVO1 = taskaVos).length, b1 = 0; b1 < j; ) {
        AggTaskAVO taskaVo = arrayOfAggTaskAVO1[b1];
        TaskABVO[] taskabVos = (TaskABVO[])taskaVo.getChildrenVO();
        TaskAHVO taskhVo = (TaskAHVO)taskaVo.getParent();
        String sbSql = " select pk_desvalue from gl_docmap where pk_docmaptemplet in ( \n select pk_docmaptemplet from gl_docmaptemplet \n where pk_srcorgbook = '" + 
          
          pk_org + "' \n" + 
          " and pk_desorgbook = '" + sphxy01 + "' \n" + 
          " and pk_srcvalue = '" + taskhVo.getCdeptid() + "' \n" + 
          " and templetcode = '001') \n";
        IUAPQueryBS iq = getIq();
        String pkdept = (String)iq.executeQuery(sbSql, (ResultSetProcessor)new ColumnProcessor());
        String deptSql = "select * from org_dept where dr=0 and enablestate=2 and pk_dept='" + pkdept + "'";
        DeptVO deptVo = (DeptVO)iq.executeQuery(deptSql, (ResultSetProcessor)new BeanProcessor(DeptVO.class));
        String orgSql = "select * from org_orgs where dr=0 and enablestate=2 and pk_org='" + sphxy01 + "'";
        OrgVO orgVo = (OrgVO)iq.executeQuery(orgSql, (ResultSetProcessor)new BeanProcessor(OrgVO.class));
        taskhVo.setCdeptid(deptVo.getPk_dept());
        taskhVo.setCdeptvid(deptVo.getPk_vid());
        taskhVo.setPk_org(orgVo.getPk_org());
        taskhVo.setPk_org_v(orgVo.getPk_vid());
        byte b2;
        int k;
        TaskABVO[] arrayOfTaskABVO1;
        for (k = (arrayOfTaskABVO1 = taskabVos).length, b2 = 0; b2 < k; ) {
          TaskABVO taskabVo = arrayOfTaskABVO1[b2];
          taskabVo.setCbdeptid(deptVo.getPk_dept());
          taskabVo.setCbdeptvid(deptVo.getPk_vid());
          taskabVo.setPk_org(orgVo.getPk_org());
          taskabVo.setPk_org_v(orgVo.getPk_vid());
          b2++;
        } 
        b1++;
      } 
      ((ITaskAMaintainService)NCLocator.getInstance().lookup(ITaskAMaintainService.class)).insert(taskaVos);
      b++;
    } 
  }
  
  private String getOrgPk() throws BusinessException {
    String sql = " SELECT pk_org FROM pub_sysinit where initcode ='sphxy01' and value ='Y'";
    return (String)getIq().executeQuery(sql, (ResultSetProcessor)new ColumnProcessor());
  }
  
  protected IUAPQueryBS getIq() {
    if (this.iq == null)
      this.iq = (IUAPQueryBS)NCLocator.getInstance().lookup(IUAPQueryBS.class); 
    return this.iq;
  }
  
  private PullDataStateVO[] getFetchDataMainAllVO() {
    return (PullDataStateVO[])this.listFetchDataMainPnl.getBillListView()
      .getBillListPanel().getHeadBillModel()
      .getBodyValueVOs(PullDataStateVO.class.getName());
  }
  
  public ListFetchDataMainPnl getListFetchDataMainPnl() {
    return this.listFetchDataMainPnl;
  }
  
  public void setListFetchDataMainPnl(ListFetchDataMainPnl listFetchDataMainPnl) {
    this.listFetchDataMainPnl = listFetchDataMainPnl;
  }
  
  public BillManageModel getModel() {
    return this.model;
  }
  
  public static String getValue(NCObject ncobj, String path) {
    Object obj = ncobj.getAttributeValue(path);
    if (obj == null)
      return ""; 
    if (obj instanceof MultiLangText)
      return XMLUtil.getXMLString(((MultiLangText)obj).getText()); 
    if (obj instanceof UFDouble)
      return ((UFDouble)obj).setScale(2, 4)
        .toString(); 
    return XMLUtil.getXMLString(obj.toString());
  }
  
  public void setModel(BillManageModel model) {
    this.model = model;
    model.addAppEventListener((AppEventListener)this);
  }
}
